//edbmf ver.0.00
// for BeBitmapFont
#include	<Be.h>

#include	"edbmf.h"
//------------------------------------------------
main()
{
	edbmf	app;
	app.Run();
}
//------------------------------------------------
edbmf::edbmf():BApplication("application/x-vnd.Beer-edbmf")
{
	BRect	frame(100,100,300,250);
	w=new edbmfwindow(frame);
}

void edbmf::RefsReceived(BMessage *mes)
{
	uint32	type;
	int32	files;
	mes->GetInfo("refs",&type,&files);
	if(files>0){
		entry_ref	eref;
		BMessage msg(B_SIMPLE_DATA);
		for(int i=0;i<files;i++){
			mes->FindRef("refs",i,&eref);
			msg.AddRef("refs",&eref);
		}
		w->PostMessage(&msg,w->v);
	}
}

void edbmf::MessageReceived(BMessage *mes)
{
	switch(mes->what){
		case B_SAVE_REQUESTED:{
			entry_ref	dir;
			const char		*name;
			mes->FindRef("directory",&dir);
			mes->FindString("name",&name);
			BMessage msg(B_SAVE_REQUESTED);
			msg.AddRef("directory",&dir);
			msg.AddString("name",name);
			w->PostMessage(&msg,w->v);
		}break;
		case B_CANCEL:{
			w->PostMessage(B_CANCEL,w->v);
		}break;
		default:{
			BApplication::MessageReceived(mes);
		}break;
	}
}
//------------------------------------------------
edbmfwindow::edbmfwindow(BRect frame):BWindow(frame,"edbmf",B_DOCUMENT_WINDOW,0)
{
	BRect	viewframe;
	viewframe.Set(0,0,200,200);
	viewframe.OffsetTo(0,20);
	v=new edbmfview(viewframe);
	AddChild(v);
	setupmenus();
	Show();
}

bool edbmfwindow::QuitRequested()
{
	be_app->PostMessage(B_QUIT_REQUESTED);
	return(true);
}

void edbmfwindow::setupmenus()
{
	BMenuBar	*mb;
	BMenu		*m;
	BMenuItem	*mi;
	mb=new BMenuBar(BRect(0,0,20,20),"menubar");
	m=new BMenu("File");
	 mi=new BMenuItem("open",new BMessage('fiop'));
	 mi->SetTarget((BHandler*)v);
	 m->AddItem(mi);
/*
	 mi=new BMenuItem("close",new BMessage('ficl'));
	 mi->SetTarget((BHandler*)v);
	 m->AddItem(mi);
*/
	 mi=new BMenuItem("save as",new BMessage('fiwr'));
	 mi->SetTarget((BHandler*)v);
	 m->AddItem(mi);
	 mi=new BMenuItem("quit",new BMessage(B_QUIT_REQUESTED));
	 mi->SetTarget((BHandler*)be_app);
	 m->AddItem(mi);
	mb->AddItem(m);
	AddChild(mb);
}
//------------------------------------------------
edbmfview::edbmfview(BRect frame):BView(frame,"edbmfview",B_FOLLOW_ALL_SIDES,B_WILL_DRAW)
{
	ef=0;
	fp=NULL;
	bm=NULL;
	mt=NULL;
	
	g=NULL;
	hd=NULL;lc=NULL;dt=NULL;
	strcpy(ff,"");strcpy(fs,"");
	
	ps=8;
	bx=10;by=100;
	
	tc=new BTextControl(BRect(30,40,150,60),"charcode","unicode=","0000",new BMessage('chgc'));
	AddChild(tc);tc->Hide();
	tw=new BTextControl(BRect(30,60,150,80),"charwidth","width=","0.0",new BMessage('chgw'));
	AddChild(tw);tw->Hide();
	bo=new BButton(BRect(100,100,150,120),"ok","ok",new BMessage('edok'));
	AddChild(bo);bo->Hide();
	bc=new BButton(BRect(50,100,100,120),"cansel","cansel",new BMessage('edca'));
	AddChild(bc);bc->Hide();
}

void edbmfview::AttachedToWindow()
{
	SetHighColor(0,0,0);
	SetViewColor(240,240,255);
	SetLowColor(180,180,200);
	tc->SetTarget(this);
	tw->SetTarget(this);
	bo->SetTarget(this);
	bc->SetTarget(this);
}

void edbmfview::Draw(BRect rect)
{
	char	s[256];
	if(ef){
		SetHighColor(0,0,0);
		SetFont(be_plain_font);
		SetFontSize(10);
		sprintf(s,"[%s]-[%s]-[%d]",ff,fs,pt);
		DrawString(s,BPoint(20,20));
		if(mt&&bm){
			SetHighColor(240,240,255);
			FillRect(BRect(bx,by-5,bx+pt*2*ps,by-2));
			SetHighColor(240,50,50);
			FillRect(BRect(bx+(pt/2)*ps,by-5,bx+(pt/2+ew)*ps,by-2));
			DrawBitmap(bm,BPoint(bx,by));
		}
	}
	if(ef==0){
		SetFont(be_bold_font);
		SetFontSize(30);
		DrawString("edbmf",BPoint(45,50));
		SetFontSize(20);
		DrawString("ver.0.00",BPoint(75,80));
	}
}

void edbmfview::MouseDown(BPoint mp)
{
	if(mt&&bm){
		int	w,h,ox,oy;
		w=pt*2;h=pt*2;ox=pt/2;oy=pt*3/2;
		if(BRect(bx,by,bx+w*ps-1,by+h*ps-1).Contains(mp)){
			BPoint	mp;
			uint32	mb;
			GetMouse(&mp,&mb);
			int	x,y,n;
			x=(mp.x-bx)/ps;
			y=(mp.y-by)/ps;
			n=w*y+x;
			if(mb&1)mt[n]=(mt[n]+1)&7;
			if(mb&2)mt[n]=(mt[n]+7)&7;
			if(mb&4)mt[n]=mt[n]?0:7;
			redraw(false);
		}
	}
}

void edbmfview::MessageReceived(BMessage *msg)
{
	switch(msg->what){
		case B_SIMPLE_DATA:{
			uint32	type;
			int32	files;
			if(!msg->GetInfo("refs",&type,&files)){
				for(int i=0;i<files;i++){
					entry_ref	eref;
					msg->FindRef("refs",i,&eref);
					load(eref);
					if(ef)break;
				}
			}
		}break;
		case B_SAVE_REQUESTED:{		//save
			entry_ref	dir;
			char	*name;
			msg->FindRef("directory",&dir);
			msg->FindString("name",(const char**)&name);
			save(dir,name);
			fp=NULL;
		}break;
		case B_CANCEL:{				//save cansel
			fp=NULL;
		}break;
		case 'fiop':{
			if(fp==NULL){
				fp=new BFilePanel(B_OPEN_PANEL,NULL,NULL,B_FILE_NODE,false);
				fp->Show();
			}
		}break;
/*
		case 'ficl':{
			if(ef){
				if(bm){delete bm;bm=NULL;}
				redraw();
			}
		}break;
*/
		case 'fiwr':{
			if(ef){
				if(fp==NULL){
					fp=new BFilePanel(B_SAVE_PANEL,NULL,NULL,B_FILE_NODE,false);
					fp->Show();
				}
			}
		}break;
		case 'chgc':{
//printf("chgc  text=[%s]\n",tc->Text());
			int	c;
			sscanf(tc->Text(),"%x",&c);
			ec=c;
//printf("chgc  ec=%04x\n",ec);
			glf2mtx();
			redraw();
		}break;
		case 'chgw':{
//printf("chgw  text=[%s]\n",tw->Text());
			float	w;
			sscanf(tw->Text(),"%f",&w);
			ew=w;
//printf("chgw  width=%f\n",ew);
			redraw();
		}break;
		case 'edok':{
//printf("edok\n");
			mtx2glf();
		}break;
		case 'edca':{
//printf("edca\n");
			glf2mtx();
			redraw();
		}break;
		default:{
			BView::MessageReceived(msg);
		}break;
	}
}

void edbmfview::redraw(bool cf)
{
	if(mt&&bm){
		uint32	*p=(uint32*)(bm->Bits());
		int		dy=bm->BytesPerRow()/4;
		int	w,h,ox,oy;
		w=pt*2;h=pt*2;ox=pt/2;oy=pt*3/2;
		for(int y=0;y<h;y++)for(int x=0;x<w;x++){
			uint32	c=pal[mt[y*w+x]];
			for(int yy=y*ps+1;yy<y*ps+ps;yy++)for(int xx=x*ps+1;xx<x*ps+ps;xx++){
				*(p+dy*yy+xx)=c;
			}
		}
		char	s[64];
		sprintf(s,"%f",ew);
		tw->SetText(s);
		if(tw->IsHidden())tw->Show();
		if(bo->IsHidden())bo->Show();
		if(bc->IsHidden())bc->Show();
	}else{
		if(!tw->IsHidden())tw->Hide();
		if(!bo->IsHidden())bo->Hide();
		if(!bc->IsHidden())bc->Hide();
	}
	if(cf)Invalidate();else Draw(Bounds());
}

void edbmfview::glf2mtx()
{	// glyph -> mt[],gw
	if(mt){delete mt;mt=NULL;}
	if(g[ec].gl>=0){
		ew=g[ec].w;
		int	w,h,ox,oy;
		w=pt*2;h=pt*2;ox=pt/2;oy=pt*3/2;
		mt=new uchar[w*h];
		for(int i=0;i<w*h;i++)mt[i]=0;

//printf("w,h=%f,%f\n",g[ec].w,g[ec].h);
//printf("l,t,r,b=%d,%d,%d,%d\n",g[ec].l,g[ec].t,g[ec].r,g[ec].b);

		uchar	*pp=g[ec].p;
		for(int y=g[ec].t;y<=g[ec].b;y++){
			int	xx=0;
			for(int x=g[ec].l;x<=g[ec].r;x++){
				int	z=(xx)?(*pp&0xf):(*pp>>4);
				mt[(oy+y-1)*w+(ox+x)]=z;
				if(xx){xx=0;pp++;}else{xx=1;}
			}
			if(xx)pp++;
		}
	}
}

void edbmfview::mtx2glf()
{	// mt[],gw -> glyph
	if(mt&&bm){
		int	w,h,ox,oy;
		int	l,t,r,b;
		w=pt*2;h=pt*2;ox=pt/2;oy=pt*3/2;
		l=t=999;	r=b=-999;
		for(int y=0;y<h;y++)for(int x=0;x<w;x++){
			if(mt[w*y+x]==0)continue;
			if(x<l)l=x;
			if(x>r)r=x;
			if(y<t)t=y;
			if(y>b)b=y;
		}

		if(g[ec].p){delete g[ec].p;g[ec].p=NULL;}
		int	p=0;
		if(l==999){	//space
			g[ec].l=0;
			g[ec].t=0;
			g[ec].r=-1;
			g[ec].b=-1;
			g[ec].gl=0;
		}else{		//non-space
			g[ec].l=l-ox;
			g[ec].t=t-oy+1;
			g[ec].r=r-ox;
			g[ec].b=b-oy+1;
			g[ec].gl=((r-l)/2+1)*(b-t+1);
			g[ec].p=new uchar[g[ec].gl];
			for(int iy=t;iy<=b;iy++)for(int ix=l;ix<=r;ix+=2){
				*(g[ec].p+p)=mt[w*iy+ix]<<4;
				if(ix<r)*(g[ec].p+p)|=mt[w*iy+ix+1];
				p++;
			}
		}
		g[ec].w=ew;
	}
}

int edbmfview::load(entry_ref &eref)
{
	FILE	*ifp,*ofp;
	char	s[256];

//printf("load\n");
	BPath	ifpt(&eref);
	char	ifn[256];
	strcpy(ifn,ifpt.Path());
//printf("[%s]\n",ifn);
	if((ifp=fopen(ifn,"rb"))==NULL)return(1);
	fread(s,1,0x24,ifp);fseek(ifp,0,0);
	hdl=B_BENDIAN_TO_HOST_INT16(*(uint16*)(s+0x08))+B_BENDIAN_TO_HOST_INT16(*(uint16*)(s+0x0a))+0x26;
	hd=new uchar[hdl];
	fread(hd,1,hdl,ifp);
	strcpy(ff,(char*)hd+0x24);
	strcpy(fs,(char*)hd+0x25+strlen(ff));
	pt=B_BENDIAN_TO_HOST_INT16(*(uint16*)(s+0x18));
	ltc=B_BENDIAN_TO_HOST_INT16(*(uint16*)(s+0x16))+1;
	lcl=ltc*8;
	lc=new uchar[lcl];
	fread(lc,1,lcl,ifp);
	dtl=B_BENDIAN_TO_HOST_INT32(*(uint32*)(s+0x04))-(hdl+lcl);
	dt=new uchar[dtl];
	fread(dt,1,dtl,ifp);
	fclose(ifp);
//printf("load ok!\n");

	if(ef){
		for(int i=0;i<65536;i++)delete g[i].p;
	}
	g=new GLYPH[65536];
	for(int i=0;i<65536;i++){
		g[i].gl=-1;	g[i].p=NULL;
	}
	dtl=0;
	int	lcp,dtp;
	lcp=0;
	while(lcp<lcl){
		uint16	c=B_BENDIAN_TO_HOST_INT16(*(uint16*)(lc+lcp+4));
		if(c){
			dtp=B_BENDIAN_TO_HOST_INT32(*(int32*)(lc+lcp))-hdl-lcl;
			g[c].l=B_BENDIAN_TO_HOST_INT16(*(int16*)(dt+dtp+8));
			g[c].t=B_BENDIAN_TO_HOST_INT16(*(int16*)(dt+dtp+10));
			g[c].r=B_BENDIAN_TO_HOST_INT16(*(int16*)(dt+dtp+12));
			g[c].b=B_BENDIAN_TO_HOST_INT16(*(int16*)(dt+dtp+14));
			g[c].w=B_BENDIAN_TO_HOST_FLOAT(*(float*)(dt+dtp+16));
			g[c].h=B_BENDIAN_TO_HOST_FLOAT(*(float*)(dt+dtp+20));
			if((g[c].l<=g[c].r)&&(g[c].t<=g[c].b)){
				g[c].gl=((g[c].r-g[c].l)/2+1)*(g[c].b-g[c].t+1);
				g[c].p=new uchar[g[c].gl];
				for(int i=0;i<g[c].gl;i++)*(g[c].p+i)=*(dt+dtp+24+i);
				dtl+=g[c].gl;
			}else{
				g[c].gl=0;
			}
		}
		lcp+=8;
	}
	delete dt;dt=NULL;
	ef=1;
//printf("read ok\n");

	if(bm){delete bm;bm=NULL;}
	int	w,h,ox,oy;
	w=pt*2;h=pt*2;ox=pt/2;oy=pt*3/2;
	bm=new BBitmap(BRect(0,0,w*ps,h*ps),B_RGB_32_BIT);
	uint32	*p=(uint32*)(bm->Bits());
	int		dy=bm->BytesPerRow()/4;
	for(int i=0;i<(w*ps+1)*(h*ps+1);i++)*(p+i)=0;
	for(int xx=0;xx<w*ps+1;xx++)*(p+dy*(oy-pt)*ps+xx)=0x777777;
	for(int yy=0;yy<h*ps+1;yy++)*(p+dy*yy+(ox+pt)*ps)=0x777777;
	for(int xx=0;xx<w*ps+1;xx++)*(p+dy*oy*ps+xx)=0xffffff;
	for(int yy=0;yy<h*ps+1;yy++)*(p+dy*yy+ox*ps)=0xffffff;
	bo->MoveTo(BPoint(120,by+h*ps+10));
	bc->MoveTo(BPoint(30,by+h*ps+10));
	if(tc->IsHidden())tc->Show();
	Invalidate();
}

int edbmfview::save(entry_ref &dir,char *name)
{
	FILE	*ifp,*ofp;
//printf("save\n");
	char	ofn[256];
	char	s[256];
	BPath	ofpt(&dir);
	sprintf(ofn,"%s/%s",ofpt.Path(),name);
//printf("[%s]\n",ofn);
	if((ofp=fopen(ofn,"wb"))==NULL)return(1);

	fseek(ofp,hdl+lcl,0);

	for(int i=0;i<ltc;i++){
		*(uint32*)(lc+i*8)=-1;
		*(uint32*)(lc+i*8+4)=0;
	}

	dtl=0;
	for(uint16 i=1;i;i++){
		if(g[i].gl<0)continue;
		int	lcp=(i<<3)^(i>>2);
		lcp&=ltc-1;
		while(*(uint32*)(lc+lcp*8)!=-1)lcp=(lcp+1)&(ltc-1);
		*(uint32*)(lc+lcp*8)=B_HOST_TO_BENDIAN_INT32((uint32)(hdl+lcl+dtl));
		*(uint16*)(lc+lcp*8+4)=B_HOST_TO_BENDIAN_INT16((uint16)i);
		*(uint16*)(lc+lcp*8+6)=0;

		s[0x00]=0x49;	s[0x01]=0x96;	s[0x02]=0xb4;	s[0x03]=0x38;
		s[0x04]=0x49;	s[0x05]=0x96;	s[0x06]=0xb4;	s[0x07]=0x40;
		*(uint16*)(s+0x08)=B_HOST_TO_BENDIAN_INT16(g[i].l);
		*(uint16*)(s+0x0a)=B_HOST_TO_BENDIAN_INT16(g[i].t);
		*(uint16*)(s+0x0c)=B_HOST_TO_BENDIAN_INT16(g[i].r);
		*(uint16*)(s+0x0e)=B_HOST_TO_BENDIAN_INT16(g[i].b);
		*(float*)(s+0x10)=B_HOST_TO_BENDIAN_FLOAT(g[i].w);
		*(float*)(s+0x14)=B_HOST_TO_BENDIAN_FLOAT(g[i].h);
		fwrite(s,1,0x18,ofp);
		if(g[i].gl>0)fwrite(g[i].p,1,g[i].gl,ofp);
		dtl+=0x18+g[i].gl;
	}

	*(uint32*)(hd+0x04)=B_HOST_TO_BENDIAN_INT32(hdl+lcl+dtl);
	fseek(ofp,0,0);
	fwrite(hd,1,hdl,ofp);
	fwrite(lc,1,lcl,ofp);
	fclose(ofp);
//printf("save ok!\n");
}
